C
C  ---------------------------------------------------------------------
C
	subroutine i2str ( n, str, les )
	character*(*) str

	character*5 form
	data form / '(Ixx)' /

	le = len(str)
	write (form(3:4),'(i2.2)') le
	write (str,form) n

	do 10,i=1,le
		if (str(i:i).ne.' ') then
			do 20,j=i,le
				ji = j-i+1
				str(ji:ji) = str(j:j)
20			continue
			str(le-i+2:) = ' '
			les = le-i+1
			return
		end if
10	continue
	les = le

	end
C
C  ---------------------------------------------------------------------
C
	LOGICAL FUNCTION ISCAP ( C )
	CHARACTER C
C
	CHARACTER*26 LETT
	DATA LETT / 'ABCDEFGHIJKLMNOPQRSTUVWXYZ' /
C
	ISCAP = INDEX(LETT,C).NE.0
	END
C
C  ---------------------------------------------------------------------
C
      FUNCTION LENGTH(STRING)
      CHARACTER STRING*(*)
      DO 71,LENGTH=LEN(STRING),1,-1
      IF(STRING(LENGTH:LENGTH).NE.' ') RETURN
 71   CONTINUE
      RETURN
      END
	program instal
	parameter ( linlen = 80, maxnit = linlen/2 )
	parameter ( maxmac = 100, maclen = 20, lenval = 20, lenfil = 20 )
	character*(maclen) mac(maxmac)
	character*(lenval) val(maxmac)
	character*(linlen) line, new
	character*(lenfil) file
	dimension is(maxnit), ie(maxnit)
	character upper1
	logical ex
	character*10 str1, str2
	character*10 mon(12)
	data mon / 'January   ',
     >           'February  ',
     >           'March     ',
     >           'April     ',
     >           'May       ',
     >           'June      ',
     >           'July      ',
     >           'August    ',
     >           'September ',
     >           'Octomber  ',
     >           'November  ',
     >           'December  '/
c  ---------------------------------------------------------------------
c  Predefined macros. Macro names must be uppercase.
	nmac = 1
	mac(nmac) = 'DATE'
	call system('date ''+%m %d %y'' > xx1xx2xx3')
	open (1,file='xx1xx2xx3')
	read (1,*) imo, ida, iye
	close(1,status='delete')
	call i2str(ida,str1,le1)
	call i2str(iye,str2,le2)
	val(nmac) = mon(imo)(1:length(mon(imo)))//' '//str1(1:le1)//
     >            ', 19'//str2(1:le2)
c
	nmac = 2
	mac(nmac) = 'TIME'
	call system('date ''+%T'' > xx1xx2xx3')
	open (1,file='xx1xx2xx3')
	read (1,'(a)') val(nmac)
	close(1,status='delete')
c  ---------------------------------------------------------------------
	inquire (file='macros',exist=ex)
	if (.not.ex) goto 800
c  Read the macro file.
	open (1,file='macros')
10	read (1,'(a)',end=20) line
	call qlcr(line,new,is,ie,nit,ierr)
c  Any error ?
	if (ierr.ne.0) then
		write (*,*) 'The macro file is incorrect.'
		write (*,'(a)') line
		stop
	end if
c  Empty line ?
	if (nit.eq.0) goto 10
c  Comment line ?
	if (new(is(1):is(1)).eq.'#') goto 10
c  Two items only allowed.
	if (nit.ne.2) then
		write (*,*) 'Incorrect line in file: macros'
		write (*,'(a)') line
		stop
	end if
	nmac = nmac+1
	if (nmac.gt.maxmac) stop 'too many macros'
	mac(nmac) = new(is(1):ie(1))
	val(nmac) = new(is(2):ie(2))
	do 80,i=1,ie(1)-is(1)+1
80		mac(nmac)(i:i) = upper1(mac(nmac)(i:i))
	goto 10

20	continue
	close (1)
c	write (*,*) 'Macro table is:'
c	do 89,i=1,nmac
c89		write (*,'(a,10x,a)') mac(i), val(i)

800	continue
c  The macro description file has been processed.
c  Process standard input
30	read (*,'(a)',end=200) line
	call qlcr(line,new,is,ie,nit,ierr)
	if (ierr.eq.0 .and. nit.eq.2) then
		call scomp(new(is(1):ie(1)),'#include',isame)
		if (isame.eq.1) then
			file = new(is(2):ie(2))
			inquire (file=file,exist=ex)
			if (ex) then
				open (10,file=file)
400				read (10,'(a)',end=401) line
      			call pol(line,mac,val,nmac)
				goto 400
401				close (10)
				goto 30
			end if
		end if
	end if
      call pol(line,mac,val,nmac)
	goto 30

200	continue
	end
	subroutine pol ( line, mac, val, nmac )

      parameter ( linlen = 80, maxnit = linlen/2 )
      parameter ( maxmac = 100, maclen = 20, lenval = 20, lenfil = 20 )

	character*(*) line, mac(*), val(*)

      character*(maclen) name
      character*(linlen) new
      character upper1, cha

	le = length(line)
	new = ' '
	ic = 0
	nnle = 0

31	continue
	ic = ic+1
	if (ic.gt.le) goto 210

	cha = line(ic:ic)
	if (cha.ne.'$') then
		nnle = nnle+1
		new(nnle:nnle) = cha
		goto 31
	end if

	ic = ic+1
	if (ic.gt.le) then
		nnle = nnle+1
		new(nnle:nnle) = cha
		goto 31
	end if
	cha = line(ic:ic)
	if (cha.ne.'(') then
		nnle = nnle+1
		new(nnle:nnle) = '$'
		nnle = nnle+1
		new(nnle:nnle) = cha
		goto 31
	end if

c  The start of a macro has been located.
	do 40,k=ic+1,le
		if (line(k:k).eq.')') goto 41
40	continue
	nnle = nnle+1
	new(nnle:nnle) = '$'
	nnle = nnle+1
	new(nnle:nnle) = '('
	goto 31

41	continue
c  The end of a macro has been located at char k.
	if (k.eq.ic+1) then
c  Empty macro.
		do 51,i=ic-1,ic
			nnle = nnle+1
			new(nnle:nnle) = line(i:i)
51		continue
		goto 31
	end if

c  Get the macro name.
	name = line(ic+1:k-1)
c  Upper case.
	lem = k-ic-1
	do 52,i=1,lem
52		name(i:i) = upper1(name(i:i))
c  Search in macro table.
	do 53,i=1,nmac
		if (mac(i).eq.name) goto 57
53	continue
	do 58,i=ic-1,k
		nnle = nnle+1
		new(nnle:nnle) = line(i:i)
58	continue
	ic = k
	goto 31

57	continue
c  Substitute.
	lev = length(val(i))
	do 54,j=1,lev
		nnle = nnle+1
		new(nnle:nnle) = val(i)(j:j)
54	continue
	ic = k
	goto 31
				
210	continue
	if (nnle.eq.0) then
		write (*,*)
	else
		write (*,'(a)') new(1:nnle)
	end if
	return

	end
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE QLCR(LINE,new,IS,IE,NIT,ierr)
      CHARACTER*(*) LINE, new
      INTEGER IS(*), IE(*)
c
      CHARACTER quote, space
	parameter ( quote = '''', space = ' ' )
c
      LOGICAL INWORD, instr, lit, ok
      CHARACTER C, tab, esc
c
	logical white
	white(c) = c.eq.space .or. c.eq.tab
C
	tab = char(9)
	esc = char(92)
c	call gettab(tab)
c	call getesc(esc)
      L = LEN(LINE)
      NIT = 0
	nn = 0
	inword = .false.
	instr = .false.
	lit = .false.
C
	ierr = 0
      DO 10,I=1,L
	   if (lit) then
		ok = .false.
		lit = .false.
	   else
		ok = .true.
	   end if
         C = LINE(I:I)
	   if (c.eq.quote .and. ok) then
		if (instr) then
c  closing quote.
		   instr = .false.
		else
c  opening quote.
		   instr = .true.
		   if (.not.inword) then
			inword = .true.
		      if (i.eq.L) then
			   ierr = 1
			   goto 20
		      else
		         nit = nit+1
			   is(nit) = nn+1
		      end if
		   end if
		end if
         else IF (white(c)) THEN
            IF (INWORD) THEN
		   if (instr) then
			nn = nn+1
			new(nn:nn) = c
		   else
                  INWORD = .FALSE.
                  IE(NIT) = nn
		   end if
            END IF
	   else if (c.eq.esc) then
		if (ok) then
		   lit = .true.
		else
		   nn = nn+1
		   new(nn:nn) = c
		end if
         ELSE
		if (inword) then
		   nn = nn+1
		   new(nn:nn) = c
            else
               INWORD = .TRUE.
		   nn = nn+1
		   new(nn:nn) = c
               NIT = NIT+1
               IS(NIT) = nn
            END IF
         END IF
10    CONTINUE
C
      IF (INWORD) then
	   IE(NIT) = nn
	   if (instr) ierr = 1
	end if
c
20	continue
      END

c  case insensitive comparison of two character strings.
c  isame = 0   -->  not equal
c  isame = 1   -->  equal

	subroutine scomp ( a, b, isame )
	character*(*) a, b

	character ca, cb, upper1
	logical blank

	la = len(a)
	lb = len(b)

	le = min(la,lb)
	do 10,i=1,le
	   ca = a(i:i)
	   cb = b(i:i)
	   ca = upper1(ca)
	   cb = upper1(cb)
	   if (ca.ne.cb) then
		isame = 0
		return
	   end if
10	continue

	if (la.gt.lb) then
	   blank = a(la+1:) .eq. ' '
	else if (lb.gt.la) then
	   blank = b(lb+1:) .eq. ' '
	else
	   blank = .true.
	end if

	if (blank) then
	   isame = 1
	else
	   isame = 0
	end if

	end
	CHARACTER FUNCTION UPPER1 ( CHA )
	CHARACTER CHA, CHA1
C
	cha1 = cha
	call upper(cha1)
	upper1 = cha1
c
	END
C
C  ---------------------------------------------------------------------
C
	SUBROUTINE UPPER ( CHA )
	CHARACTER*(*) CHA
C
	CHARACTER C
	LOGICAL ISCAP
C
	DO 10,I=1,LEN(CHA)
	   C = CHA(I:I)
	   IF (.NOT.ISCAP(C)) THEN
	      IC = ICHAR(C)
	      IF (IC.GE.97 .AND. IC.LE.122) CHA(I:I) = CHAR(IC-32)
	   END IF
10	CONTINUE
C
	END
