C  Maximum length of a keyword.
	PARAMETER ( KEYLEN = 10 )
C  Maximum number of panel commands.
	PARAMETER ( MXPCOM = 50 )
C  Maximum number of keywords in all panel commands.
	PARAMETER ( MXPKEY = 500 )
C  Maximum storage for integer/real keywords.
	PARAMETER ( MXPIR = 3000 )
C  Maximum storage for string keywords and descriptions.
	PARAMETER ( MXPSTR = 8000 )
C  Maximum number of pointers in the above string storage.
	PARAMETER ( MXPPST = 1000 )
C
	CHARACTER*(KEYLEN)      PCOM(MXPCOM)
	INTEGER                 PONF(MXPCOM)
	INTEGER                 KPOINT(MXPCOM)
	INTEGER                 NCHELP(2*MXPCOM)
	CHARACTER*(KEYLEN)      PKEY(MXPKEY)
	INTEGER                 NKHELP(2*MXPKEY)
	CHARACTER               KTYPE(MXPKEY)
	INTEGER                 TPOINT(MXPKEY)
	CHARACTER               KIO(MXPKEY)
	$(TYPE)                 PIR(MXPIR)
	INTEGER                 SPOINT(MXPPST)
	CHARACTER*(MXPSTR)      PANSTR
	COMMON /PCOMS1/ KPOINT, NCHELP, NKHELP, TPOINT, SPOINT, PONF
	COMMON /PCOMS2/ PIR
	COMMON /PCOMS3/ PKEY, KTYPE, PANSTR, PCOM, KIO
C
C  NPCOM: Number of panel commands in the panel description file.
C  NPKEY: Number of keywords in all panel commands.
C  NPIR:  Number of positions filled in array PIR.
C  NPSP:  Number of positions filled in the char-pointer array SPOINT.
C  NPCH:  Number of character positions filled in PANSTR.
	COMMON /PCOMS4/ NPCOM, NPKEY, NPIR, NPSP, NPCH
